package fr.bordeaux.poo;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.util.Enumeration;
import java.util.Hashtable;

import javax.swing.ImageIcon;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;

public class View {
	
	Game g;
	
	JFrame frame;
	
	Dimension dim;
	ImageIcon iconInvader, iconShip;
	
	JPanel gamePanel;
	
	Hashtable<Invader , JLabel> labelInvaders;
	JLabel labelShip;
	
	
	public View(Game g) {
		this.g = g;
		this.labelInvaders = new Hashtable<Invader, JLabel>();
	}
	
	public JFrame getFrame() {
		return frame;
	}
	
	public void createInvaderLabel(Invader i) {
		JLabel invaderLabel = new JLabel(iconInvader);
		invaderLabel.setBounds(i.getX() , i.getY() , i.getWidth() , i.getHeight());
		gamePanel.add(invaderLabel);
		labelInvaders.put(i, invaderLabel);
	}
	
	public void init() {
		//Frame
		frame = new JFrame("Space Invader");
		frame.getContentPane().setLayout(new BorderLayout());
		
		//Center Panel
		dim = new Dimension(Map.MAP_WIDTH, Map.MAP_HEIGHT);
		gamePanel = new JPanel();
		gamePanel.setMinimumSize(dim);
		gamePanel.setMaximumSize(dim);
		gamePanel.setSize(dim);
		frame.getContentPane().add(gamePanel, BorderLayout.CENTER);
		gamePanel.setLayout(null);
		
		//Icons
		iconInvader = new ImageIcon(this.getClass().getResource("invader.gif"));
		iconShip = new ImageIcon(this.getClass().getResource("ship.gif"));
				
		//The ship
		labelShip = new JLabel(iconShip);
		labelShip.setBounds(g.getShip().getX(), g.getShip().getY(), Map.SHIP_WIDTH, Map.SHIP_HEIGHT);
		gamePanel.add(labelShip);
		
		
		//The Invaders
		for (Invader i: g.getInvaders()) createInvaderLabel(i);
		
		
		frame.setSize(dim);
		frame.setMinimumSize(dim);
		frame.setMaximumSize(dim);
		frame.pack();
		frame.setVisible(true);
	}
	
	
	private void createInvaderLabels() {
		for (Invader i : g.getInvaders()) {
			if (!labelInvaders.containsKey(i)) createInvaderLabel(i);
 		}
	}
	
	private void refreshLabelEntity(JLabel l ,Entity e) {
		l.setBounds(e.getX(), e.getY(), e.getWidth(), e.getHeight());
	}
	
	public void refresh() {
		createInvaderLabels();
		
		//Invaders
		Enumeration<Invader> ei = labelInvaders.keys();
		while  (ei.hasMoreElements()) {
			Invader i = ei.nextElement();
			if (i.isAlive) refreshLabelEntity(labelInvaders.get(i), i);
		}
		
	}


	public JLabel getLabelShip() {
		return labelShip;
	}

}
